#!/bin/sh
#
# Find a user's in/out traffic by username.
# Syntax:
#  pppoetraffic.sh <router ip> <snmp community> <snmp version> <username>

ROUTER=$1
ROCOMMUNITY=$2
SNMPVERSION=$3
USERNAME=$4

SNMPWALK="/usr/local/bin/snmpwalk"
SNMPGET="/usr/local/bin/snmpget"

VPDNNUM=`$SNMPWALK -On -v $SNMPVERSION -c $ROCOMMUNITY $ROUTER 1.3.6.1.4.1.9.10.24.1.3.2.1.2.2 | grep "\"$USERNAME\"" | cut -f1 -d'=' | sed 's/.1.3.6.1.4.1.9.10.24.1.3.2.1.2.//'`

if [ "$VPDNNUM" != "" ]
then
  IFNUM=`$SNMPGET -Oqv -v $SNMPVERSION -c $ROCOMMUNITY $ROUTER 1.3.6.1.4.1.9.10.24.1.3.2.1.11.$VPDNNUM`
else
  IFNUM=0
fi

if [ "$IFNUM" = "0" ]
then
  INOCTETS=0
  OUTOCTETS=0
else
  INOCTETS=`$SNMPGET -Oqv -v $SNMPVERSION -c $ROCOMMUNITY $ROUTER ifInOctets.$IFNUM`
  OUTOCTETS=`$SNMPGET -Oqv -v $SNMPVERSION -c $ROCOMMUNITY $ROUTER ifOutOctets.$IFNUM`
fi

echo "in_traffic:$INOCTETS out_traffic:$OUTOCTETS"
